from __main__ import RMAPPlugin0

def print_custom( value ):
	print value
	RMAPPlugin0.ProcessPendingEvents()

def print_reg_fft( address ):
	fft_reg = RMAPPlugin0.Read( address, 1)
	out_ren 		= (fft_reg[0] & 0x0000001f)
	out_reuse 		= (fft_reg[0] & 0x000003e0) >> 5
	out_locked 		= (fft_reg[0] & 0x00007c00) >> 10
	MEM_IN_SM_Full  = (fft_reg[0] & 0x000f8000) >> 15
	MEM_IN_SM_Empty	= (fft_reg[0] & 0x01f00000) >> 20
	print "out_ren = " + bin( out_ren ) \
			+ ", out_reuse = " + bin( out_reuse ) \
			+ ", out_locked = " + bin( out_locked ) \
			+ ", MEM_IN_SM_Full = " + bin( MEM_IN_SM_Full ) \
			+ ", MEM_IN_SM_Empty = " + bin( MEM_IN_SM_Empty )
	RMAPPlugin0.ProcessPendingEvents()

def print_reg_sm( address ):
	sm_reg = RMAPPlugin0.Read( address, 1)
	out_ren 		 = (sm_reg[0] & 0x00000003)
	MEM_OUT_SM_Full  = (sm_reg[0] & 0x0000000c) >> 2
	MEM_OUT_SM_Empty = (sm_reg[0] & 0x00000030) >> 4
	MEM_OUT_SM_Full_s= (sm_reg[0] & 0x00000040) >> 6
	print "sm_reg = "  + bin( sm_reg[0] & 0x7f ) \
			+ ", MEM_OUT_SM_Full_s = " + bin( MEM_OUT_SM_Full_s ) \
			+ ", MEM_OUT_SM_Empty = " + bin( MEM_OUT_SM_Empty ) \
			+ ", MEM_OUT_SM_Full = " + bin( MEM_OUT_SM_Full ) \
			+ ", out_ren = " + bin( out_ren )
	RMAPPlugin0.ProcessPendingEvents()

def print_reg_sm_only_MEM_IN_CTRL( address ):
	sm_reg = RMAPPlugin0.Read( address, 1)
	out_wen 		 = (sm_reg[0] & 0x0000001f)
	MEM_IN_SM_Full   = (sm_reg[0] & 0x000003e0) >> 5
	MEM_IN_SM_Empty  = (sm_reg[0] & 0x00007c00) >> 10
	MEM_IN_SM_Locked = (sm_reg[0] & 0x000f8000) >> 15
	print "MEM_IN_SM = "    + bin( sm_reg[0] & 0xfffff ) \
			+ ", Locked = " + bin( MEM_IN_SM_Locked ) \
			+ ", Empty = "  + bin( MEM_IN_SM_Empty ) \
			+ ", Full = "   + bin( MEM_IN_SM_Full ) \
			+ ", wen = "    + bin( out_wen )
	RMAPPlugin0.ProcessPendingEvents()

def print_reg_sm_only_MEM_OUT_CTRL( address ):
	sm_reg = RMAPPlugin0.Read( address, 1)
	MEM_IN_SM_Empty  = (sm_reg[0] & 0x00000030) >> 4
	MEM_IN_SM_Full   = (sm_reg[0] & 0x0000000c) >> 2
	out_ren 		 = (sm_reg[0] & 0x00000003)
	print "MEM_OUT_SM = "    + bin( sm_reg[0] & 0x3f ) \
			+ ", Empty = "  + bin( MEM_IN_SM_Empty ) \
			+ ", Full = "   + bin( MEM_IN_SM_Full ) \
			+ ", ren = "    + bin( out_ren )
	RMAPPlugin0.ProcessPendingEvents()
