#============================
# ADRESSES FOR THE FFT MODULE
# FIFO F0
FFT_FIFO_F0_1_0 = 0x80000f00
FFT_FIFO_F0_3_2 = 0x80000f04
FFT_FIFO_F0_4   = 0x80000f08
FFT_FIFO_F0_WEN	= 0x80000f0c
# FIFO F1
FFT_FIFO_F1_1_0 = 0x80000f10
FFT_FIFO_F1_3_2 = 0x80000f14
FFT_FIFO_F1_4   = 0x80000f18
FFT_FIFO_F1_WEN	= 0x80000f1c
# FIFO F2
FFT_FIFO_F2_1_0 = 0x80000f20
FFT_FIFO_F2_3_2 = 0x80000f24
FFT_FIFO_F2_4   = 0x80000f28
FFT_FIFO_F2_WEN	= 0x80000f2c

FFT_MEM_IN_SM_0 = 0x80000f30
FFT_MEM_IN_SM_1 = 0x80000f34
FFT_MEM_IN_SM_2 = 0x80000f38
FFT_MEM_IN_SM_3 = 0x80000f3c
FFT_MEM_IN_SM_4 = 0x80000f40

FFT_CTRL		 = 0x80000f44

#================================
# ADDRESSES FOR THE FFT_SM DESIGN
FFT_SM_MEM_OUT_SM_0	   = 0x80000f30
FFT_SM_MEM_OUT_SM_1	   = 0x80000f34
FFT_SM_MEM_OUT_SM_CTRL = 0x80000f38

#=================================
# ADDRESSES FOR THE SM_ONLY DESIGN
SM_ONLY_MEM_IN_SM_0		= 0x80000f00
SM_ONLY_MEM_IN_SM_1		= 0x80000f04
SM_ONLY_MEM_IN_SM_2		= 0x80000f08
SM_ONLY_MEM_IN_SM_3		= 0x80000f0c
SM_ONLY_MEM_IN_SM_4		= 0x80000f10

SM_ONLY_MEM_IN_SM_CTRL	= 0x80000f14

SM_ONLY_MEM_OUT_SM_0	= 0x80000f18
SM_ONLY_MEM_OUT_SM_1	= 0x80000f1c

SM_ONLY_MEM_OUT_CTRL	= 0x80000f20

#======================
# GENERAL USE CONSTANTS
mask_REN_FIFO_0		= 0xfffffffe	# 1110
mask_REN_FIFO_1		= 0xfffffffd	# 1101
#
columnV  = 1
columnE1 = 2
columnE2 = 3
columnB1 = 4
columnB2 = 5
columnB3 = 6